DEFINT A-Z
DECLARE SUB READBLOCK (buf$)
'$DYNAMIC
OPTION BASE 1

DIM blocks(45, 2)
DIM bit(80, 16), col(80, 2), pat(8), o$(0 TO 255)

white$ = CHR$(255) + CHR$(255) + CHR$(255)
black$ = CHR$(0) + CHR$(0) + CHR$(0)

CLS
FOR i = 0 TO 255
LOCATE 1, 1: PRINT USING "Please wait: ###"; 255 - i
o$(i) = SPACE$(8)
p = i
r$ = ""
FOR kk = 7 TO 0 STEP -1
  pp = p - (2 ^ kk)
  IF pp >= 0 THEN r$ = r$ + black$: p = pp ELSE r$ = r$ + white$
NEXT kk
o$(i) = r$
NEXT i

CLS
PRINT "Input filename: ";
LINE INPUT filename$
filename$ = UCASE$(filename$)
IF filename$ = "" OR LEN(filename$) > 12 THEN PRINT "Invalid filename.": END
PRINT

OPEN filename$ FOR BINARY ACCESS READ AS 1
OPEN "output.ppm" FOR OUTPUT AS 2

READBLOCK buffer$:       'first sector

m$ = MID$(buffer$, 22, 2)
IF m$ <> CHR$(1) + CHR$(7) THEN PRINT "Not a Converted GEOS file.": END

realfile$ = MID$(buffer$, 4, 16)
x = INSTR(realfile$, ""): IF x > 0 THEN realfile$ = LEFT$(realfile$, x - 1)
PRINT : PRINT "C64 filename: "; realfile$

READBLOCK buffer$:      'second sector

m$ = MID$(buffer$, 76, 11)
IF m$ <> "Paint Image" THEN PRINT "Not a GEOS Paint Image file."

comment$ = MID$(buffer$, 159)
x = INSTR(comment$, CHR$(0)): IF x > 0 THEN comment$ = LEFT$(comment$, x - 1)
PRINT "Comment: "; comment$

READBLOCK buffer$:      'third sector

FOR i = 1 TO 45
  m$ = LEFT$(buffer$, 2)
  blocks(i, 1) = ASC(m$)
  IF blocks(i, 1) <> 0 THEN blocks(i, 2) = ASC(RIGHT$(m$, 1))
  buffer$ = MID$(buffer$, 3)
NEXT i

'start to output picture format.
PRINT #2, "P6"
PRINT #2, "640 720"
PRINT #2, "255"



' display loop

done = 90
FOR i = 1 TO 45
FOR l = 1 TO 16
FOR k = 1 TO 80
 bit(k, l) = 0
NEXT k
NEXT l

done = done - 1
LOCATE 8, 1
PRINT USING "To-go: ##"; done

IF blocks(i, 1) > 0 THEN
dat$ = ""
FOR j = 1 TO blocks(i, 1)
READBLOCK buffer$
IF j = blocks(i, 1) THEN buffer$ = LEFT$(buffer$, blocks(i, 2))
dat$ = dat$ + buffer$
NEXT j

bitposh = 1
bitposv = 1

dpos = 1

DO WHILE bitposh - 1 + (bitposv - 1) * 80 < 1280 AND LEN(dat$) >= dpos

nxt = ASC(MID$(dat$, dpos, 1) + CHR$(0))
dpos = dpos + 1

SELECT CASE nxt
  CASE 1 TO 63
    num = nxt
    FOR k = 1 TO num
      dt = ASC(MID$(dat$, dpos, 1) + CHR$(0))
      dpos = dpos + 1
      bit(bitposh, bitposv) = dt
      bitposv = bitposv + 1: IF bitposv = 9 OR bitposv = 17 THEN bitposh = bitposh + 1: bitposv = bitposv - 8: IF bitposh > 80 THEN bitposh = bitposh - 80: bitposv = bitposv + 8
      IF bitposh - 1 + (bitposv - 1) * 80 >= 1280 OR LEN(dat$) < dpos THEN EXIT DO
    NEXT k
  CASE 65 TO 127
    num = nxt AND 63
    FOR k = 1 TO 8
      pat(k) = ASC(MID$(dat$, dpos, 1) + CHR$(0))
      dpos = dpos + 1
    NEXT k
    FOR l = 1 TO num
      FOR k = 1 TO 8
      bit(bitposh, bitposv) = pat(k)
      bitposv = bitposv + 1: IF bitposv = 9 OR bitposv = 17 THEN bitposh = bitposh + 1: bitposv = bitposv - 8: IF bitposh > 80 THEN bitposh = bitposh - 80: bitposv = bitposv + 8
      IF bitposh - 1 + (bitposv - 1) * 80 >= 1280 OR LEN(dat$) < dpos THEN EXIT DO
      NEXT k
    NEXT l
  CASE 129 TO 255
    num = nxt - 128
      dt = ASC(MID$(dat$, dpos, 1) + CHR$(0))
      dpos = dpos + 1
      FOR k = 1 TO num
        bit(bitposh, bitposv) = dt
      bitposv = bitposv + 1: IF bitposv = 9 OR bitposv = 17 THEN bitposh = bitposh + 1: bitposv = bitposv - 8: IF bitposh > 80 THEN bitposh = bitposh - 80: bitposv = bitposv + 8
      IF bitposh - 1 + (bitposv - 1) * 80 >= 1280 OR LEN(dat$) < dpos THEN EXIT DO
      NEXT k
  CASE ELSE
      PRINT "e"; nxt; i; dpos; "ex "
END SELECT

LOOP

END IF

done = done - 1
LOCATE 8, 1
PRINT USING "To-go: ##"; done

' output

FOR l = 1 TO 16
b$ = ""
FOR k = 1 TO 80
  p = bit(k, l)
b$ = b$ + o$(p)
NEXT k
PRINT #2, b$;
NEXT l

NEXT i

CLOSE 2
CLOSE 1

PRINT

REM $STATIC
SUB READBLOCK (buf$)

buf$ = SPACE$(254)
GET #1, , buf$

END SUB

